#!/bin/sh

#The idea of using just udev and at to do the automounting came to me
#(louigi600 at yahoo dot com) one sleepless night. You can do whatever 
#you want with it as long as:
#1) you do not claim the intellectual idea
#2) you tell me ho you modified or added to the idea
#3) I'll be more incline in forgiving 1 and 2 if you donate something to the
#project
 
PATH=/bin:/usr/bin:/sbin:/usr/sbin
VENDOR=$(cat ${2}/../device/vendor |tr -d " ")
DEVICE="/dev/$1"

[ -z "$VENDOR" ] && VENDOR=$1 || VENDOR=${VENDOR}_$1
MOUNTPOINT="/media/$VENDOR"
PARTID=$(fdisk  -l |grep $DEVICE |tr -d "\*" |awk  '{print $5}')

if [ -s /var/run/atd.pid ]
then
  logger AUTOMOUNT: scheduling at job for: mount $DEVICE $MOUNTPOINT
  [ ! -d $MOUNTPOINT ] && /bin/mkdir $MOUNTPOINT

  #stopping momentarily atd
  kill -SIGSTOP $(cat /var/run/atd.pid)
  sleep 1 
  #scheduling job now while atd is stopped
  at -q t "now" << EOF |/usr/bin/logger
/bin/mount $DEVICE $MOUNTPOINT 
/usr/bin/logger /bin/mount $DEVICE $MOUNTPOINT
EOF
  #cleaning up scheduled job from messed up environmemt (thanks udev)
  JOBFILE=$(ls -lrt /var/spool/atjobs/ |tail -1 |awk '{print $NF}')
  grep -v "; export " /var/spool/atjobs/$JOBFILE > /tmp/$JOBFILE
  cat /tmp/$JOBFILE > /var/spool/atjobs/$JOBFILE
  #restarting atd and hopefully it will pick up the scheduled job
  sync
  kill -SIGCONT $(cat /var/run/atd.pid)
else
  mkdir -p /dev/runme/
  echo "#!/bin/sh 
PATH=/bin:/usr/bin:/sbin:/usr/sbin ; export PATH
[ ! -d $MOUNTPOINT ] && /bin/mkdir $MOUNTPOINT
/bin/mount $DEVICE $MOUNTPOINT
/usr/bin/logger /bin/mount $DEVICE $MOUNTPOINT
" > /dev/runme/$VENDOR
  
  chmod 700 /dev/runme/$VENDOR
fi
